unit FStyleViewer;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Themes;

type
  TForm1 = class(TForm)
    lbApplicationStyles: TListBox;
    btnGetStyles: TButton;
    btnChangeStyle: TButton;
    btnLoadStyleFromFile: TButton;
    procedure btnGetStylesClick(Sender: TObject);
    procedure btnChangeStyleClick(Sender: TObject);
    procedure btnLoadStyleFromFileClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btnChangeStyleClick(Sender: TObject);
var
  StyleName : String;
  SelectedItemIndex : Integer;
begin
  try
    // Get currently selected style from TListBoxItem.
    //SelectedItemIndex := lbApplicationStyles.ItemIndex;
    // Extract the name of the currently selected style.
    //StyleName := lbApplicationStyles.Items[SelectedItemIndex];
    // Set the currently selected style as current style.
    TStyleManager.SetStyle('Amakrits');
  except
    // This exception is triggered if the user doesn't select a style from the TListBox
    on excep : EStringListError do
      ShowMessage('Please select a Style');
  end;
end;

procedure TForm1.btnGetStylesClick(Sender: TObject);
var
  MyApplicationStyle : String;
  counter : Integer;
begin
  // Get a list of styles that the Application supports.
  for MyApplicationStyle in TStyleManager.StyleNames do
    // Add the Style name to the TListBox.
    lbApplicationStyles.Items.Add(MyApplicationStyle);
end;

procedure TForm1.btnLoadStyleFromFileClick(Sender: TObject);
var
  StyleFolder : String;
  SearchResults : TSearchRec;
  LoadedStyle : TStyleManager.TStyleServicesHandle;
begin
  StyleFolder := ExtractFilePath(ParamStr(0))+'MyAppStyles'+
  PathDelim;
  if DirectoryExists(StyleFolder) then
  begin
    if FindFirst(StyleFolder + '*.*', faAnyFile - faDirectory, SearchResults) = 0 then
    repeat
      try
        if TStyleManager.IsValidStyle(StyleFolder + SearchResults.Name) then
          LoadedStyle := TStyleManager.LoadFromFile(StyleFolder + SearchResults.Name);
          TStyleManager.SetStyle(LoadedStyle);
      except on E : Exception do
        ShowMessage(E.Message);
      end;
    until FindNext(searchResults) <> 0;
  end;
end;

end.
